<template>
  <div class="storage-selector card">
    <h5 class="card-header">Select tables</h5>
    <div class="card-body row">
      <item-selector
        class="kex-selector col-12 col-md-6 col-lg-4"
        :multiple="false"
        v-model="kex"
        :items="availableKexes"
        :badges="kexBadges"
        >Select kex:</item-selector
      >
      <item-selector
        class="table-selector col-12 col-md-6 col-lg-4"
        :multiple="multiple"
        v-model="selected[selectedKex]"
        :items="availableTables"
        :key="(selected[selectedKex] || '') + selectedKex"
        @select="tablesSelected"
        >Select tables:</item-selector
      >
      <div class="col-12 col-lg-4">
        <div>
          Selected tables:
          <tables-listing
            :data="selected"
            @removeKex="removeKex"
            @removeTable="removeTable"
          />
        </div>
        <button
          type="button"
          @click="$emit('select', selected)"
          class="btn btn-success m-2"
        >
          <i class="fas fa-check"></i> Confirm
        </button>
        <button
          type="button"
          @click="$emit('select', null)"
          class="btn btn-secondary m-2"
        >
          <i class="fas fa-times"></i> Close
        </button>
      </div>
      <api-data endpoint="/storage/tree" v-model="storageTree" />
    </div>
  </div>
</template>

<script>
export default {
  name: "StorageSelector",
  data() {
    return {
      kex: [],
      tables: [],
      storageTree: {},
      selected: {},
    };
  },
  props: {
    multiple: {
      type: Boolean,
    },
  },
  methods: {
    tablesSelected(event) {
      this.selected[this.selectedKex] = [...event];
      if (this.selected[this.selectedKex].length === 0)
        this.removeKex(this.selectedKex);
    },
    removeKex(kex) {
      if (Object.prototype.hasOwnProperty.call(this.selected, kex)) {
        delete this.selected[kex];
      }
    },
    removeTable({ kex, table }) {
      if (
        Object.prototype.hasOwnProperty.call(this.selected, kex) &&
        this.selected[kex].includes(table)
      ) {
        this.selected[kex] = this.selected[kex].filter(
          (entry) => entry != table
        );
        if (this.selected[kex].length == 0) this.removeKex(kex);
      }
    },
  },
  computed: {
    availableKexes() {
      return Object.fromEntries(
        Array.from(Object.keys(this.storageTree)).map((kex) => [kex, kex])
      );
    },
    availableTables() {
      if (this.selectedKex === null) return {};
      return Object.fromEntries(
        Array.from(this.storageTree[this.selectedKex]).map((table) => [
          table.table,
          table.table,
        ])
      );
    },
    selectedKex() {
      if (this.kex.length === 0) return null;
      return this.kex[0];
    },
    currentTables() {
      if (this.selectedKex === null) return [];
      return this.selected[this.selectedKex] || [];
    },
    kexBadges() {
      return Object.fromEntries(
        Object.keys(this.selected).map((kex) => [
          kex,
          `${this.selected[kex].length} selected`,
        ])
      );
    },
  },
};
</script>

<style lang="scss">
.list-group-item.kex {
  &::after {
    display: inline;
    content: ">";
    right: 1rem;
    position: absolute;
  }
}
</style>
